#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <asm/io.h>
#include <asm/delay.h>
#include <unistd.h>

#define PP_DATA 0x378            /* Parallel port data byte address    */
#define PP_STATUS 0x379          /* Parallel port status byte address  */
#define PP_CONTROL 0x37a         /* Parallel port control byte address */

#define CS         1             /* CS* bit                            */

/*****************************************************************************/
/* Initialize MultiMediaCard                                                 */
/*****************************************************************************/
void initmmc()
{
   extern void cmd();
   extern int spi();
   int i,inbyte,junk;

/* take CS* pin high
*/
   outb(CS,PP_DATA);

/* shift out 10 FFh's holding CS high
*/
   for(i=0;i<10;i++)inbyte=spi(0xff,CS);

/* take CS* pin low to select card
*/
   outb(0,PP_DATA);
   inbyte=spi(0xff,0);
   inbyte=spi(0xff,0);

/* send CMD0 to enable SPI mode on MMC
*/
   cmd(0,0,0,0,0);
   inbyte=spi(0xff,0);

/* send CMD 1 to start card
*/
   cmd(1,0,0,0,0);
}
