#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
/*#include <asm/io.h>*/
#include <sys/io.h>
#include <asm/delay.h>
/*#include <unistd.h>*/

#define PP_DATA 0x378            /* Parallel port data byte address    */
#define PP_STATUS 0x379          /* Parallel port status byte address  */
#define PP_CONTROL 0x37a         /* Parallel port control byte address */


/*****************************************************************************/
/* Reads and writes an MMC card over the parallel port                       */
/*****************************************************************************/

main()
{
   extern void initmmc(),cmd(),openblockr(),openblockw();
   extern int closeblock();
   extern int spi();
   int error,i,inbyte;

   int icsd[19],read_bl_len,c_size,c_size_mult,mem,write_bl_len,numblocks;
   int lenblockr,lenblockw,iaddress;
   int nblocks;

   int iopt,idone;
   FILE *fp;
   char ofile[73],ifile[73];
   int iblock,ibyte;

   unsigned char ibuffer[512];
   int numread;

/* open parallel port
*/
   error=ioperm(PP_DATA,3,1);
   if(error){
      printf("Parallel port failed to open\n");
      exit(0);
   }

/* make sure interrupt is off and stuff can be output on data port
*/
   outb(0,PP_CONTROL);

/* initialize multimediacard
*/
   initmmc();

/* read and print the 19 bytes CID
*/
/*   cmd(10,0,0,0,0);
   for(i=0;i<19;i++){
      inbyte=spi(0xff,0)&0xff;
      printf("%d\n",inbyte&0xff);
   }
   inbyte=spi(0xff,0)&0xff;
   printf("\n");*/

/* get block size and number of blocks from CSD
*/
   cmd(9,0,0,0,0);
   for(i=0;i<19;i++){
      icsd[i]=spi(0xff,0)&0xff;
      printf("%d\n",icsd[i]);
   }
   inbyte=spi(0xff,0)&0xff;

   read_bl_len=icsd[6]&0x0f;
   c_size=((icsd[7]*256*256+icsd[8]*256+icsd[9])&0x0003ffc0)>>6;
   c_size_mult=((icsd[10]*256+icsd[11])&0x00000280)>>7;
   numblocks=(c_size+1)<<(2+c_size_mult);
   mem=numblocks<<read_bl_len;
   printf("Card has %f MB of memory\n",(float)mem/1024./1024.);

   write_bl_len=9;

   lenblockr=1<<read_bl_len;
   lenblockw=1<<write_bl_len;


/* infinite loop getting user input
*/
   do{

/* get user input
*/
      printf("\n                         \n");
      printf("MMC reader                 \n");
      printf("  0. Quit                  \n");
      printf("  1. Read card             \n");
      printf("  2. Write file to card    \n");
      printf("  3. Erase card            \n");
      printf("choice: ");
      scanf("%d",&iopt);

/* quit or...
*/
      if(iopt == 0){
         break;

/* ...read the card or...
*/
      }else if(iopt == 1){
         printf("output filename > ");
         scanf("%s",ofile);
         fp=fopen(ofile,"wb");

         openblockr(0);
         nblocks=spi(0xff,0);
         nblocks<<=8;
         nblocks+=spi(0xff,0);
         nblocks<<=8;
         nblocks+=spi(0xff,0);
         nblocks<<=8;
         nblocks+=spi(0xff,0);
         nblocks/=512;
         nblocks--;
         for(ibyte=5;ibyte<=lenblockr+3;ibyte++)inbyte=spi(0xff,0);

         idone=0;
         for(iblock=1;iblock<nblocks;iblock++){
            openblockr(iblock*lenblockr);
            for(ibyte=0;ibyte<lenblockr;ibyte++){
               inbyte=spi(0xff,0);
               fwrite(&inbyte,1,1,fp);
            }
            inbyte=spi(0xff,0);
            inbyte=spi(0xff,0);
            inbyte=spi(0xff,0);
         }
         fclose(fp);

/* ...dump a file to the card or...
*/
      }else if(iopt == 2){
         printf("file to dump to card > ");
         scanf("%s",ifile);
         fp=fopen(ifile,"rb");

         openblockw(0);
         

         idone=0;
         for(iblock=0;iblock<numblocks;iblock++){
            numread=(int)fread(ibuffer,1,lenblockw,fp);
            if(numread == 0)break;
            iaddress=iblock*lenblockw;

            for(ibyte=0;ibyte<numread;ibyte++){
               inbyte=spi((int)*(ibuffer+ibyte),0);
            }
            if(numread < lenblockw){
               for(ibyte=numread;ibyte<lenblockw;ibyte++){
                  inbyte=spi(0xff,0);
               }
            }
            inbyte=spi(0xff,0);           /* dummy CRC            */
            for(i=0;i<256;i++){           /* wait for response R1 */
               inbyte=spi(0xff,0);
               if(inbyte != 255)break;
            }
            if(inbyte == 255){
               printf("no response from card after write\n");
               exit(1);
            }
            inbyte&=0x1f;                 /* check response       */
            if(inbyte == 11){
               printf("CRC error when writing to card\n");
               exit(1);
            }
            for(i=0;i<256;i++){           /* wait for card to finish prog */
               inbyte=spi(0xff,0);
               if(inbyte != 0)break;
            }
            inbyte=spi(0xff,0);
            cmd(13,0,0,0,0);              /* get status bytes */
            inbyte=spi(0xff,0);
            inbyte=spi(0xff,0);
         }
         fclose(fp);

      }

/* end of infinite loop
*/
   }while(1);

/* close the port
*/
   for(i=0;i<10;i++)inbyte=spi(0xff,0);
   ioperm(PP_DATA,3,0);
}
