#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <sys/io.h>
#include <asm/delay.h>

#define PP_DATA 0x378            /* Parallel port data byte address    */
#define PP_STATUS 0x379          /* Parallel port status byte address  */
#define PP_CONTROL 0x37a         /* Parallel port control byte address */

/*****************************************************************************/
/* open a memory block for reading                                           */
/*****************************************************************************/
void openblockr(iaddress)

int iaddress;
{
   extern void cmd();
   int inbyte,i,igot;
   int iaddr0,iaddr1,iaddr2,iaddr3;

/* split address into four bytes
*/
   iaddr3=(iaddress>>24)&0xff;
   iaddr2=(iaddress>>16)&0xff;
   iaddr1=(iaddress>> 8)&0xff;
   iaddr0=(iaddress>> 0)&0xff;

/*   printf("%d %d %d %d %d\n",iaddress,iaddr0,iaddr1,iaddr2,iaddr3);*/

/* send command 17 to the MMC to tell it to read a block
*/
   cmd(17,iaddr3,iaddr2,iaddr1,iaddr0);

/* look for start-of-data token or error byte
*/
   igot=0;
   for(i=0;i<256;i++){
      inbyte=spi(0xff,0);
      if(inbyte != 0xff){
         igot=1;
         break;
      }
   }
   if(igot == 0){
      printf("Did not receive start-of-data token\n");
      exit(3);
   }
   if(inbyte != 0xfe){
      printf("Error %d waiting for start-of-data token\n");
      exit(4);
   }
}
