#define PP_DATA   0x378            /* Parallel port data byte address    */
#define PP_STATUS 0x379            /* Parallel port status byte address  */

#define SCK 64                     /* Serial clock bit position          */

#include <stdio.h>
#include <math.h>
#include <asm/io.h>
#include <asm/delay.h>
#include <unistd.h>

/*********************************** spi **********************************/
/*                                                                        */
/* Emulates an SPI port sending one byte out.  Returns the value shifted  */
/* in during the send.                                                    */
/*                                                                        */
/**************************************************************************/
int spi(ibyte,ics)

int ibyte,ics;
{
   int ibit,iout,itmp,inbyte;

   inbyte=0;
   for(ibit=0;ibit<8;ibit++)
   {
      iout=(ibyte>>4)&0x08;
      outb(iout+ics,PP_DATA);
      outb(iout+ics+SCK,PP_DATA);
/*      outb(iout+ics,PP_DATA);*/
      ibyte<<=1;

      itmp=inb(PP_STATUS);
      itmp>>=5;
      inbyte<<=1;
      inbyte+=itmp&0x01;
   }

   return(inbyte);
}
